
org 16514

; this value has to match the 'base' variable in loader.txt
;
basemem equ 32768

; difference between original location and load-to location
;
vh 		equ HIGH(basemem)
adjoffs	equ vh-$40


load:
	push	iy
	ld		iy,basemem
	ld		(iy+$15),$41

	ld		d,0						; set d to zero as indicator.
										; in-byte sets d to 1 when a byte has been received

   ld    hl,16444             ; store the name in the printer buffer

ld_name:
	call	in_byte					; received byte in c.
	ld		(hl),c
	inc	hl
	ld		a,c						; transfer byte to a.
	rla								; test for inverted bit.
	jr		nc,ld_name

	ld		hl,basemem+9			; start loading program here

ld_prog:
	ld		d,1
	call	in_byte					; routine in-byte loads a byte
	ld		(hl),c					; insert assembled byte in memory.

	inc	hl							;
	ex		de,hl						;
	ld		hl,(basemem+$14)		; sv - e_line.
	
	ld		a,adjoffs            ;;; add a fudge factor to cope with the change of base page
	add	a,h
	ld		h,a

	scf
	sbc	hl,de
	ex		de,hl
	jr		nc,ld_prog				; return if more bytes to load/save.

	ld		bc,1						; indicate success
	pop	iy
	ret









in_byte:
	ld		c,$01						; prepare an eight counter 00000001.

next_bit:
	ld		b,$00						; set counter to 256

break_3:
	ld		a,$7f						; read the keyboard row 
	in		a,($fe)					; with the space key.

	out	($ff),a					; output signal to screen.

	rra								; test for space pressed.
	jr		nc,break_4				; forward if so to break-4

	rla								; reverse above rotation
	rla								; test tape bit.
	jr		c,get_bit				; forward if set to get-bit

	djnz	break_3					; loop back to break-3

	ld		a,d						; timeout - tape has stopped if d is nonzero
	and	a
	jr		z,in_byte
	jr		break_4

get_bit:
	push	de							; save the 
	ld		e,$94						; timing value.

trailer:
	ld		b,$1a						; counter to twenty six.

counter:
	dec	e							; decrement the measuring timer.
	in		a,($fe)					;
	rla								;
	bit	7,e						;
	ld		a,e						;
	jr		c,trailer				; loop back with carry to trailer

	djnz	counter					; to counter

	pop	de							;
	jr		nz,bit_done				; to bit-done

	cp		$56						;
	jr		nc,next_bit				; to next-bit

bit_done:
	ccf								; complement carry flag
	rl		c							;
	jr		nc,next_bit				; to next-bit

	ret								; return with full byte.




break_4:
	pop	iy							; popping return address
	pop	iy
	ld		bc,0
	ret


.end

